疯狂java


您现在的位置: 疯狂软件 >> 新闻资讯 >> 正文

深入理解Java异常处理机制


 

   1 引子

  try…catch…finally恐怕是大家再熟悉不过的语句了,而且感觉用起来也是很简单,逻辑上似乎也是很轻易理解。不过,我亲自体验的“教训”告诉我,这个东西可不是想象中的那么简单、听话。不信?那你看看下面的代码,“猜猜”它执行后的结果会是什么?不要往后看答案、也不许执行代码看真正答案哦。假如你的答案是正确,那么这篇文章你就不用浪费时间看啦。

  package myExample.testException;

  public class TestException {

  public TestException() {

  }

  boolean testEx() throws Exception{

  boolean ret = true;

  try{

  ret = testEx1();

  }catch (Exception e){

  System.out.PRintln("testEx, catch exception");

  ret = false;

  throw e;

  }finally{

  System.out.println("testEx, finally; return value="+ret);

  return ret;

  }

  }

  boolean testEx1() throws Exception{

  boolean ret = true;

  try{

  ret = testEx2();

  if (!ret){

  return false;

  }

  System.out.println("testEx1, at the end of try");

  return ret;

  }catch (Exception e){

  System.out.println("testEx1, catch exception");

  ret = false;

  throw e;

  }

  finally{

  System.out.println("testEx1, finally; return value="+ret);

  return ret;

  }

  }

  boolean testEx2() throws Exception{

  boolean ret = true;

  try{

  int b=12;

  int c;

  for (int i=2;i>=-2;i--){

  c=b/i;

  System.out.println("i="+i);

  }

  return true;

  }catch (Exception e){

  System.out.println("testEx2, catch exception");

  ret = false;

  throw e;

  }

  finally{

  System.out.println("testEx2, finally; return value="+ret);

  return ret;

  }

  }

  public static void main(String[] args) {

  TestException testException1 = new TestException();

  try{

  testException1.testEx();

  }catch(Exception e){

  e.printStackTrace();

  }

  }

  }

  你的答案是什么?是下面的答案吗?

  i=2

  i=1

  testEx2, catch exception

  testEx2, finally; return value=false

  testEx1, catch exception

  testEx1, finally; return value=false

  testEx, catch exception

  testEx, finally; return value=false

  假如你的答案真的如上面所说,那么你错啦。^_^,那就建议你仔细看一看这篇文章或者拿上面的代码按各种不同的情况修改、执行、测试,你会发现有很多事情不是原来想象中的那么简单的。

  现在公布正确答案:

  i=2

  i=1

  testEx2, catch exception

  testEx2, finally; return value=false

  testEx1, finally; return value=false

  testEx, finally; return value=false

  2 基础知识

  2.1 相关概念

  例外是在程序运行过程中发生的异常事件,比如除0溢出、数组越界、文件找不到等,这些事件的发生将阻止程序的正常运行。为了加强程序的鲁棒性,程序设计时,必须考虑到可能发生的异常事件并做出相应的处理。C语言中,通过使用if语句来判定是否出现了例外,同时,调用函数通过被调用函数的返回值感知在被调用函数中产生的例外事件并进行处理。全程变量ErroNo经常用来反映一个异常事件的类型。但是,这种错误处理机制会导致不少问题。

  java通过面向对象的方法来处理例外。在一个方法的运行过程中,假如发生了例外,则这个方法生成代表该例外的一个对象,并把它交给运行时系统,运行时系统寻找相应的代码来处理这一例外。我们把生成例外对象并把它提交给运行时系统的过程称为抛弃(throw)一个例外。运行时系统在方法的调用栈中查找,从生成例外的方法开始进行回朔,直到找到包含相应例外处理的方法为止,这一个过程称为捕捉(catch)一个例外。

  2.2 Throwable类及其子类

  用面向对象的方法处理例外,就必须建立类的层次。类 Throwable位于这一类层次的最顶层,只有它的后代才可以做为一个例外被抛弃。图1表示了例外处理的类层次。

  类Throwable有两个直接子类:Error和Exception。Error类对象(如动态连接错误等),由Java虚拟机生成并抛弃(通常,Java程序不对这类例外进行处理);Exception类对象是Java程序处理或抛弃的对象。它有各种不同的子类分别对应于不同类型的例外。其中类RuntimeException代表运行时由Java虚拟机生成的例外,如算术运算例外ArithmeticException(由除0错等导致)、数组越界例外ArrayIndexOutOfBoundsException等;

  其它则为非运行时例外,如输入输出例外IOException等。Java编译器要求Java程序必须捕捉或声明所有的非运行时例外,但对运行时例外可以不做处理。

  2.3 异常处理要害字

  Java的异常处理是通过5个要害字来实现的:try,catch,throw,throws,finally。JB的在线帮助中对这几个要害字是这样解释的:

  Throws: Lists the exceptions a method could throw.

  Throw:  Transfers control of the method to the exception handler.

  Try:  Opening exception-handling statement.

  Catch: Captures the exception.

  Finally: Runs its code before terminating the program.

  2.3.1 try语句

  try语句用大括号{}指定了一段代码,该段代码可能会抛弃一个或多个例外。

  2.3.2 catch语句

  catch语句的参数类似于方法的声明,包括一个例外类型和一个例外对象。例外类型必须为Throwable类的子类,它指明了catch语句所处理的例外类型,例外对象则由运行时系统在try所指定的代码块中生成并被捕捉,大括号中包含对象的处理,其中可以调用对象的方法。

  catch语句可以有多个,分别处理不同类的例外。Java运行时系统从上到下分别对每个catch语句处理的例外类型进行检测,直到找到类型相匹配的catch语句为止。这里,类型匹配指catch所处理的例外类型与生成的例外对象的类型完全一致或者是它的父类,因此,catch语句的排列顺序应该是从非凡到一般。

  也可以用一个catch语句处理多个例外类型,这时它的例外类型参数应该是这多个例外类型的父类,程序设计中要根据具体的情况来选择catch语句的例外处理类型。

  2.3.3 finally语句

  try所限定的代码中,当抛弃一个例外时,其后的代码不会被执行。通过finally语句可以指定一块代码。无论try所指定的程序块中抛弃或不抛弃例外,也无论catch语句的例外类型是否与所抛弃的例外的类型一致,finally所指定的代码都要被执行,它提供了统一的出口。通常在finally语句中可以进行资源的清除工作。如关闭打开的文件等。

  2.3.4 throws语句

  throws总是出现在一个函数头中,用来标明该成员函数可能抛出的各种异常。对大多数Exception子类来说,Java 编译器会强迫你声明在一个成员函数中抛出的异常的类型。假如异常的类型是Error或 RuntimeException, 或它们的子类,这个规则不起作用, 因为这在程序的正常部分中是不期待出现的。 假如你想明确地抛出一个RuntimeException,你必须用throws语句来声明它的类型。

  2.3.5 throw语句

  throw总是出现在函数体中,用来抛出一个异常。程序会在throw语句后立即终止,它后面的语句执行不到,然后在包含它的所有try块中(可能在上层调用函数中)从里向外寻找含有与其匹配的catch子句的try块。

  3 要害字及其中语句流程详解

  3.1     try的嵌套

  你可以在一个成员函数调用的外面写一个try语句,在这个成员函数内部,写另一个try语句保护其他代码。每当碰到一个try语句,异常的框架就放到堆栈上面,直到所有的try语句都完成。假如下一级的try语句没有对某种异常进行处理,堆栈就会展开,直到碰到有处理这种异常的try语句。下面是一个try语句嵌套的例子。

  class MultiNest {

  static void procedure() {

  try {

  int a = 0;

  int b = 42/a;

  } catch(java.lang.ArithmeticException e) {

  System.out.println("in procedure, catch ArithmeticException: " + e);

  }

  }

  public static void main(String args[]) {

  try {

  procedure();

  }